;;;;;;;;;;;;
; Tune and save OSCCAL register
;     OSCCAL

OSCCAL_Draw:
 ldi	r16, 0x0
 sts	DS_Buf0, r16
 ldi	r16, 0x5
 sts	DS_Buf1, r16
 ldi	r16, 0x17
 sts	DS_Buf2, r16

 in	r16, OSCCAL
 swap	r16
 andi	r16, 0xF
 sts	DS_Buf3, r16
 
 in	r16, OSCCAL
 andi	r16, 0xF
 sts	DS_Buf4, r16
 ret

OSCCAL_k3:
 in	r16, OSCCAL
 dec	r16
 rjmp	OC_1

OSCCAL_k4:
 in	r16, OSCCAL
 inc	r16
OC_1:
 out	OSCCAL, r16
 rcall	f_Write
 rjmp	SendIR

;;;;;;;;;;;;
;    OSCCAL
f_Write:
 rcall	f_WWait

 in	r17, OSCCAL
 clr	r16
 out	EEARH, r16
 rcall	f_W_1

 com	r17
 inc	r16
 rcall	f_WWait

f_W_1:
 out	EEARL, r16
 out	EEDR, r17
 cli
 sbi	EECR, EEMWE
 sbi	EECR, EEWE
 sei
 ret

;;;;;;;;;;;;
;    OSCCAL,   
f_Read:
 rcall	f_WWait

 clr	r16
 out	EEARL, r16
 out	EEARH, r16
 sbi	EECR, EERE
 in	r17, EEDR

 inc	r16
 out	EEARL, r16
 sbi	EECR, EERE
 in	r16, EEDR

 com	r16
 cp	r16, r17
 brne	f_R_1
 out	OSCCAL, r16
f_R_1:
 ret

;
;   
;         sleep modes !
;
f_WWait:
 sbic	EECR, EEWE
 rjmp	f_WWait
 ret
